package com.yourdomain.agent;

import net.bytebuddy.agent.builder.AgentBuilder;
import net.bytebuddy.asm.Advice;
import net.bytebuddy.matcher.ElementMatchers;
import net.bytebuddy.description.type.TypeDescription;
import net.bytebuddy.utility.JavaModule;
import net.bytebuddy.dynamic.DynamicType;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.lang.instrument.Instrumentation;
import java.security.ProtectionDomain;

public class CheckrpAgent {
    private static final String OUT_PATH = "D:/Minectaft/Milk/milk1/dev/packets.txt";

    public static void premain(String agentArgs, Instrumentation inst) {
        try {
            File f = new File(OUT_PATH);
            f.getParentFile().mkdirs();
            if (!f.exists()) f.createNewFile();
        } catch (Exception e) {
            e.printStackTrace();
        }

        new AgentBuilder.Default()
                .ignore(ElementMatchers.nameStartsWith("net.bytebuddy."))
                .ignore(ElementMatchers.nameStartsWith("java."))
                .type(ElementMatchers.named("net.minecraftforge.network.simple.SimpleChannel"))
                .transform((
                                DynamicType.Builder<?> builder,
                                TypeDescription typeDescription,
                                ClassLoader classLoader,
                                JavaModule module,
                                ProtectionDomain pd
                        ) ->
                                builder.visit(Advice.to(SendAdvice.class)
                                        .on(ElementMatchers.named("sendToServer")
                                                .and(ElementMatchers.takesArguments(1))
                                        )
                                )
                )
                .installOn(inst);
    }

    public static class SendAdvice {
        @Advice.OnMethodEnter
        public static void onEnter(@Advice.Argument(0) Object packet) {
            String className = packet.getClass().getName();
            String line ="["+className +"]  "+ (packet == null ? "null" : packet.toString()) + System.lineSeparator();
            try (BufferedWriter out = new BufferedWriter(new FileWriter(OUT_PATH, true))) {
                out.write(line);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
